/*****************************************************************************
 *                DigCC: a minimal C compiler for DigMIPS                    *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2012 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#ifndef __BASIC_BLOCK_H
#define __BASIC_BLOCK_H

#include "BitVector.h"
#include "Code.h"
#include "PseudoCode.h"

#include <vector>

using namespace std;

class BasicBlock: public Code
{
 public:
  vector<Code*> block;

  BitVector* read_register; //block input
  BitVector* write_register; //block output

  string label;

  BasicBlock(vector<Code*> vec);

  //
  //Implementation of abstract methods
  //

  //Selectors
  BitVector* get_read_register(); //use
  BitVector* get_write_register(); //def
  string get_label();

  //Predicates
  int is_jump();
  int is_label();

  BasicBlock* clone();

  //Pretty printer
  string to_string();
  string to_string_dot();
};

#endif
