/*****************************************************************************
 *                DigCC: a minimal C compiler for DigMIPS                    *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2012 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#ifndef __CODE_H
#define __CODE_H

#include "BitVector.h"

using namespace std;

class Code
{
 public:
  //Abstract selectors
  virtual BitVector* get_read_register()=0; //use
  virtual BitVector* get_write_register()=0; //def
  virtual string get_label()=0;

  //Abstract predicates
  virtual int is_jump()=0;
  virtual int is_label()=0;

  virtual Code* clone()=0;

  //Abstract pretty printer
  virtual string to_string()=0;
  virtual string to_string_dot()=0; //For dot output
};

#endif
